<?php
/*
Plugin Name: WS AudioPlayer
Plugin URI: http://www.icyleaf.cn/2007/11/05/plugins-ws-audio-player-09-released/
Description: 可在日志插入且附带下载功能的在线Flash播放器。点<a href="admin.php?page=wsaudioplayer/options-wsaudioplayer.php">这里</a>查看详细说明以及相关设置。
Version: 0.9.5
Author: icyleaf
Author URI: http://www.icyleaf.cn
*/

// Global variables
$ws_version = "0.9.5";
$ws_playerURL = get_settings('siteurl') . '/wp-content/plugins/ws-audio-player/audioplayer.swf';

function ws_add_options_page() {
	add_options_page('WS AudioPlayer Options', 'WS AudioPlayer', 'manage_options', 'ws-audio-player/options-wsaudioplayer.php');
}
add_action('admin_head', 'ws_add_options_page');

// Declare instances global variable
$ws_instances = array();

// Filter function (inserts player instances according to behaviour option)
function ws_insert_player($content = '') {
	global $ws_behaviour, $ws_instances;
	
	// Reset instance array
	$ws_instances = array();
	$content = preg_replace_callback( "/\[audio=(([^]]+))]/i", "ws_player", $content );
	return $content;
}

// Callback function for preg_replace_callback
function ws_player($matches) {
	global $ws_playerURL, $ws_instances, $ws_playerID;
	
	// Get next player ID
	$ws_playerID++;
	// Build FlashVars string (url encode everything)
	$flashVars = "audio" . $ws_playerID;
	
	// Split options
	$data = preg_split("/[\|]/", $matches[2]);
	$files = array();

	foreach( explode( ",", $data[0] ) as $afile ) {
		array_push( $files, $afile );
	}
	$file = implode( ",", $files );

	$source = split( ",", $file );
	
	
	if(is_feed()) {
		if($source[1]!=""){
			_e('<br />作者使用<a href="http://www.icyleaf.cn/tag/ws-audioplayer/" title="这个是什么插件?">WS Audio Player</a>插入了一音乐，下载(<a href="' . $source[0] . '" ','wsap');
			_e('title="下载' . $source[1] . '"/>' . $source[1] . '</a>)','wsap');
		}else{
			_e('<br />作者使用<a href="http://www.icyleaf.cn/tag/ws-audioplayer/" title="这个是什么插件?">WS Audio Player</a>插入了一音乐，(<a href="' . $source[0] . '" />','wsap');
			_e('下载</a>)此音乐','wsap');
		}
	}else{

	echo '<div class="wsaudioplayer">';
	echo '<div class="wsflashplayer">';
	echo '<embed width="100%" height="26" flashvars="url=' . $source[0] . '" wmode="transparent" quality="high" class="audio" name="' . $flashVars . '" src="' . $ws_playerURL . '" type="application/x-shockwave-flash"/></embed></div>';

	if($source[2]=="download")  {
		echo '<a href="' . $source[0] . '" ';
		_e('title="下载' . $source[1] .'" class="wsdownload">Download</a>','wsap');
	}
	if($source[1]!="") echo '<span class="wsmusicdesc">'. $source[1] . '</span>';
	echo '</div></p>';
	}
}
// Add filter hook
add_filter('the_content', 'ws_insert_player');


function ws_wp_head() {
	global $ws_playerID;
	
	$wsap_css = get_option('wsap_css_setting');
	switch( $wsap_css ) {
		case 'ws_css_white':$wsap_css = "screen_white.css";break;
		case 'ws_css_blue':$wsap_css = "screen_blue.css";break;
		case 'ws_css_custom':$wsap_css = "screen.css";break;
		default:$wsap_css = "screen_white.css";
	}
	
	echo "\n<!--Begin[CSS for WS Audio Player]-->\n\t";
	echo '<link type="text/css" rel="stylesheet" href="' . get_settings("siteurl") . '/wp-content/plugins/ws-audio-player/css/' . $wsap_css  .'" />';
	echo "\n<!--End[CSS for WS Audio Player]-->\n\n";
}
add_action('wp_head', 'ws_wp_head');



if (strpos($_SERVER['REQUEST_URI'], 'post.php') || strpos($_SERVER['REQUEST_URI'], 'post-new.php') || strpos($_SERVER['REQUEST_URI'], 'page-new.php') || strpos($_SERVER['REQUEST_URI'], 'page.php')) {
add_action('admin_footer', 'wsap_AddQuickTag');

function wsap_AddQuickTag(){
echo '<script type="text/javascript">
		<!--
		var wsapToolbar = document.getElementById("ed_toolbar");
		if(wsapToolbar){
			var wsapNr = edButtons.length;';

echo "edButtons[edButtons.length] = new edButton('ed_wsap','','','','');";
echo 'var wsapBut = wsapToolbar.lastChild;
			while (wsapBut.nodeType != 1){
				wsapBut = wsapBut.previousSibling;
			}
			
			wsapBut = wsapBut.cloneNode(true);
			wsapToolbar.appendChild(wsapBut);
			//toolbar.appendChild(wsapBut);
			wsapBut.value = \'MP3\';
			wsapBut.onclick = edInsertwsap;
			wsapBut.title = "Input Music with WS Audio Player plugins";
			wsapBut.id = "ed_wsp";
		}
		
		function edInsertwsap() {
			if(!edCheckOpenTags(wsapNr)){';
			
			echo "var U = prompt('";
			_e('请输入MP3地址','wsap');
			echo "' , 'http://');
					var W = prompt('";
			_e('是否显示歌曲名,不显示请留空','wsap');
			echo "' , '');
					var H = prompt('";
			_e('是否可以下载,不可以请留空,默认为可以下载','wsap');
			echo "' , 'download');
					var theTag = '[audio=' + U + ',' + W + ',' + H + ']';";
			echo	'edButtons[wsapNr].tagStart  = theTag;
				edInsertTag(edCanvas, wsapNr);
			} else {
				edInsertTag(edCanvas, wsapNr);
			}
		}

		//-->
		</script>';
}
}
?>